Xapian: API Documentation: Xapian::ValuePostingSource Class Reference

xapian-core 2.0.0

Public Member Functions | List of all members
Xapian::ValuePostingSource Class Reference

A posting source which generates weights from a value slot. More...

`#include <postingsource.h>`

Inheritance diagram for Xapian::ValuePostingSource:
[legend]

## Public Member Functions
| ValuePostingSource (Xapian::valueno slot_) noexcept
| Construct a ValuePostingSource.
Xapian::doccount | get_termfreq_min () const
| A lower bound on the number of documents this object can return.
Xapian::doccount | get_termfreq_est () const
| An estimate of the number of documents this object can return.
Xapian::doccount | get_termfreq_max () const
| An upper bound on the number of documents this object can return.
void | next (double min_wt)
| Advance the current position to the next matching document.
void | skip_to (Xapian::docid min_docid, double min_wt)
| Advance to the specified docid.
bool | check (Xapian::docid min_docid, double min_wt)
| Check if the specified docid occurs.
bool | at_end () const
| Return true if the current position is past the last entry in this list.
Xapian::docid | get_docid () const
| Return the current docid.
void | reset (const Database &db_, Xapian::doccount shard_index)
| Set this PostingSource to the start of the list of postings.
Xapian::Database | get_database () const
| The database we're reading values from.
Xapian::valueno | get_slot () const
| The slot we're reading values from.
std::string | get_value () const
| Read current value.
void | done ()
| End the iteration.
bool | get_started () const
| Flag indicating if we've started (true if we have).
void | set_termfreq_min (Xapian::doccount termfreq_min_)
| Set a lower bound on the term frequency.
void | set_termfreq_est (Xapian::doccount termfreq_est_)
| An estimate of the term frequency.
void | set_termfreq_max (Xapian::doccount termfreq_max_)
| An upper bound on the term frequency.
std::string | get_description () const
| Return a string describing this object.
Public Member Functions inherited from Xapian::PostingSource
| PostingSource () noexcept
| Allow subclasses to be instantiated.
void | set_maxweight (double max_weight)
| Specify an upper bound on what get_weight() will return from now on.
double | get_maxweight () const noexcept
| Return the currently set upper bound on what get_weight() can return.
virtual double | get_weight () const
| Return the weight contribution for the current document.
virtual PostingSource * | clone () const
| Clone the posting source.
virtual std::string | name () const
| Name of the posting source class.
virtual std::string | serialise () const
| Serialise object parameters into a string.
virtual PostingSource * | unserialise (const std::string &serialised) const
| Create object given string serialisation returned by serialise().
virtual PostingSource * | unserialise_with_registry (const std::string &serialised, const Registry &registry) const
| Create object given string serialisation returned by serialise().
virtual void | init (const Database &db)
| Older method which did the same job as reset().
PostingSource * | release ()
| Start reference counting this object.
const PostingSource * | release () const
| Start reference counting this object.

## Detailed Description

A posting source which generates weights from a value slot.

This is a base class for classes which generate weights using values stored in the specified slot. For example, ValueWeightPostingSource uses sortable_unserialise to convert values directly to weights.

The upper bound on the weight returned is set to DBL_MAX. Subclasses should call set_maxweight() in their init() methods after calling ValuePostingSource::init() if they know a tighter bound on the weight.

## Constructor & Destructor Documentation

## ◆ ValuePostingSource()

Xapian::ValuePostingSource::ValuePostingSource | ( | Xapian::valueno | slot_ | ) |
| inlineexplicitnoexcept

Construct a ValuePostingSource.

Parameters

  slot_ | The value slot to read values from.

## Member Function Documentation

## ◆ at_end()

bool Xapian::ValuePostingSource::at_end | ( |  | ) | const
| virtual

Return true if the current position is past the last entry in this list.

At least one of next(), skip_to() or check() will be called before this method is first called.

Implements Xapian::PostingSource.

## ◆ check()

bool Xapian::ValuePostingSource::check | ( | Xapian::docid | did,
|  | double | min_wt )
| virtual

Check if the specified docid occurs.

The caller is required to ensure that the specified document id did actually exists in the database. If it does, it must move to that document id, and return true. If it does not, it may either:

- return true, having moved to a definite position (including "at_end"), which must be the same position as skip_to() would have moved to.

or

- return false, having moved to an "indeterminate" position, such that a subsequent call to next() or skip_to() will move to the next matching position after did.

Generally, this method should act like skip_to() and return true if that can be done at little extra cost.

Otherwise it should simply check if a particular docid is present, returning true if it is, and false if it isn't.

The default implementation calls skip_to() and always returns true.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the reset() method for details.

Parameters

  did | The document id to check.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::PostingSource.

## ◆ done()

void Xapian::ValuePostingSource::done | ( |  | ) |
| inline

End the iteration.

Calls to at_end() will return true after calling this method.

Since
  Added in 1.2.23 and 1.3.5.

## ◆ get_database()

Xapian::Database Xapian::ValuePostingSource::get_database | ( |  | ) | const
| inline

The database we're reading values from.

Since
  Added in 1.2.23 and 1.3.5.

## ◆ get_description()

std::string Xapian::ValuePostingSource::get_description | ( |  | ) | const
| virtual

Return a string describing this object.

This default implementation returns a generic answer. This default it provided to avoid forcing those deriving their own PostingSource subclass from having to implement this (they may not care what get_description() gives for their subclass).

Reimplemented from Xapian::PostingSource.

Reimplemented in Xapian::ValueWeightPostingSource.

## ◆ get_docid()

Xapian::docid Xapian::ValuePostingSource::get_docid | ( |  | ) | const
| virtual

Return the current docid.

This method may assume that it will only be called when there is a "current document". See get_weight() for details.

Note: in the case of a multi-database search, the returned docid should be in the single subdatabase relevant to this posting source. See the reset() method for details.

Implements Xapian::PostingSource.

## ◆ get_slot()

Xapian::valueno Xapian::ValuePostingSource::get_slot | ( |  | ) | const
| inline

The slot we're reading values from.

Since
  Added in 1.2.23 and 1.3.5.

## ◆ get_started()

bool Xapian::ValuePostingSource::get_started | ( |  | ) | const
| inline

Flag indicating if we've started (true if we have).

Since
  Added in 1.2.23 and 1.3.5.

## ◆ get_termfreq_est()

Xapian::doccount Xapian::ValuePostingSource::get_termfreq_est | ( |  | ) | const
| virtual

An estimate of the number of documents this object can return.

It must always be true that:

get_termfreq_min() <= get_termfreq_est() <= get_termfreq_max()

Xapian will always call reset() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

## ◆ get_termfreq_max()

Xapian::doccount Xapian::ValuePostingSource::get_termfreq_max | ( |  | ) | const
| virtual

An upper bound on the number of documents this object can return.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

## ◆ get_termfreq_min()

Xapian::doccount Xapian::ValuePostingSource::get_termfreq_min | ( |  | ) | const
| virtual

A lower bound on the number of documents this object can return.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

## ◆ get_value()

std::string Xapian::ValuePostingSource::get_value | ( |  | ) | const
| inline

Read current value.

Since
  Added in 1.2.23 and 1.3.5.

## ◆ next()

void Xapian::ValuePostingSource::next | ( | double | min_wt | ) |
| virtual

Advance the current position to the next matching document.

The PostingSource starts before the first entry in the list, so next(), skip_to() or check() must be called before any methods which need the context of the current position.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Parameters

  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Implements Xapian::PostingSource.

## ◆ reset()

void Xapian::ValuePostingSource::reset | ( | const Database & | db,
|  | Xapian::doccount | shard_index )
| virtual

Set this PostingSource to the start of the list of postings.

This is called automatically by the matcher prior to each query being processed.

If a PostingSource is used for multiple searches, reset() will therefore be called multiple times, and must handle this by using the database passed in the most recent call.

Parameters

  db | The database which the PostingSource should iterate through.
  shard_index | The 0-based index indicating which shard in a multi-database db is. This can be useful if you have an external source of postings corresponding to each shard.

Note: in the case of a multi-database search, a separate PostingSource will be used for each database (the separate PostingSources will be obtained using clone()), and each PostingSource will be passed one of the sub-databases as the db parameter here. The db parameter will therefore always refer to a single database. All docids passed to, or returned from, the PostingSource refer to docids in that single database, rather than in the multi-database.

A default implementation is provided which calls the older init() method to allow existing subclasses to continue to work, but the default implementation of init() throws Xapian::InvalidOperationError so you must override either this method or init(). In new code, override this method in preference.

Since
  Added in Xapian 2.0.0.

Reimplemented from Xapian::PostingSource.

Reimplemented in Xapian::ValueWeightPostingSource.

## ◆ set_termfreq_est()

void Xapian::ValuePostingSource::set_termfreq_est | ( | Xapian::doccount | termfreq_est_ | ) |
| inline

An estimate of the term frequency.

Subclasses should set this if they are overriding the next(), skip_to() or check() methods.

Since
  Added in 1.2.23 and 1.3.5.

## ◆ set_termfreq_max()

void Xapian::ValuePostingSource::set_termfreq_max | ( | Xapian::doccount | termfreq_max_ | ) |
| inline

An upper bound on the term frequency.

Subclasses should set this if they are overriding the next(), skip_to() or check() methods.

Since
  Added in 1.2.23 and 1.3.5.

## ◆ set_termfreq_min()

void Xapian::ValuePostingSource::set_termfreq_min | ( | Xapian::doccount | termfreq_min_ | ) |
| inline

Set a lower bound on the term frequency.

Subclasses should set this if they are overriding the next(), skip_to() or check() methods to return fewer documents.

Since
  Added in 1.2.23 and 1.3.5.

## ◆ skip_to()

void Xapian::ValuePostingSource::skip_to | ( | Xapian::docid | did,
|  | double | min_wt )
| virtual

Advance to the specified docid.

If the specified docid isn't in the list, position ourselves on the first document after it (or at_end() if no greater docids are present).

If the current position is already the specified docid, this method will leave the position unmodified.

If the specified docid is earlier than the current position, the behaviour is unspecified. A sensible behaviour would be to leave the current position unmodified, but it is also reasonable to move to the specified docid.

The default implementation calls next() repeatedly, which works but skip_to() can often be implemented much more efficiently.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the reset() method for details.

Parameters

  did | The document id to advance to.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::PostingSource.

The documentation for this class was generated from the following file:

- xapian/postingsource.h